Integer sets as a (deeply embedded) language - a grammar of constructors

> {-# LANGUAGE GADTs, KindSignatures #-}

> module SetLanguageDeep(IntegerSet(Empty, Insert, Delete), member) where

>   data IntegerSet :: * where
>     Empty  ::                          IntegerSet
>     Insert :: IntegerSet -> Integer -> IntegerSet
>     Delete :: IntegerSet -> Integer -> IntegerSet

Now member is an operation over the terms of the language, not itself part of the language.

>   member :: IntegerSet -> Integer -> Bool
>   member Empty y = False
>   member (Insert xs x) y = (y==x) || member xs y
>   member (Delete xs x) y = (y/=x) && member xs y

 


