Integer sets as a (shallow embedded) language - direct interpretation

> module SetLanguageShallow(IntegerSet, empty, insert, delete, member) where

>   newtype IntegerSet = IS (Integer->Bool)

>   empty   ::                           IntegerSet
>   empty = IS (\ y -> False)

>   insert  :: IntegerSet -> Integer ->  IntegerSet
>   insert (IS f) x  = IS (\ y -> (y==x) || f y)

>   delete  :: IntegerSet -> Integer ->  IntegerSet
>   delete (IS f) x  = IS (\ y -> (y/=x) && f y)

>   member  :: IntegerSet -> Integer -> Bool
>   member (IS f) = f



