Integer sets as a module - hidden data representation, using State monad

> module SetModule(Set, runSet, insert, delete, member) where

>   import Control.Monad.State

>   type IntegerSet = [Integer]

>   newtype Set a = S { runS :: State IntegerSet a }

>   instance Monad Set where
>     return a  = S (return a)
>     m >>= k   = S (runS m >>= (runS . k))

>   runSet :: Set a -> a
>   runSet x = evalState (runS x) []

>   insert :: Integer -> Set ()
>   insert x  = S $ do { modify (x:) }

>   delete :: Integer -> Set ()
>   delete x  = S $ do { modify (filter (/=x)) }

>   member :: Integer -> Set Bool
>   member x  = S $ do { xs <- get ; return (any (==x) xs) }

