> import Data.Char (isSpace, isDigit, digitToInt)
> import System.Environment (getArgs, getProgName)
> import SetLanguageShallow

----------------------------------------------------------------------

> type Parser a = String -> [(a,String)]

> runParser :: Parser a -> String -> Either a String
> runParser p s = case p s of 
>   [(a,s)] -> if all isSpace s then Left a else Right ("Leftover input: " ++ s)
>   [] -> Right "No parse"
>   x -> Right ("Ambiguous, with leftovers " ++ show (map snd x))

> success :: a -> Parser a
> success x s = [(x,s)]

> failure :: Parser a
> failure s = []

> infixl <*>

> (<*>) :: Parser (a->b) -> Parser a -> Parser b
> (p <*> q) s = [ (f a, s'') | (f,s') <- p s, (a,s'') <- q s' ]

> (<|>) :: Parser a -> Parser a -> Parser a
> (p <|> q) s = p s ++ q s

> match :: (Char->Bool) -> Parser Char
> match q [] = []
> match q (c:s) = if q c then [(c,s)] else []

----------------------------------------------------------------------

> main :: IO ()
> main = do 
>   ss <- getArgs
>   case ss of
>     [s]  -> case runParser program s of
>       Left b   -> putStrLn ("Succeeded: " ++ show b)
>       Right s  -> putStrLn ("Failed: " ++ s)
>     _    -> do
>       n <- getProgName
>       putStrLn ("Usage: " ++ n ++ " <set-expr>")

----------------------------------------------------------------------

The remainder is to be completed during the exercises.

> (<*) :: Parser a -> Parser b -> Parser a
> p <* q = undefined

> (*>) :: Parser a -> Parser b -> Parser b
> p *> q = undefined

> some, many :: Parser a -> Parser [a]
> some p  = undefined
> many p  = undefined

> whitespace, ows :: Parser ()
> whitespace  = undefined
> ows         = undefined

> token :: String -> Parser ()
> token ""    = undefined
> token (c:t) = undefined

> program :: Parser Bool
> program = undefined


